"use strict";

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { "default": obj }; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.copy = copy;
exports.copySync = copySync;
exports.watch = watch;

var _Cpx = require("./cpx");

var _Cpx2 = _interopRequireWildcard(_Cpx);

exports.Cpx = _Cpx2["default"];

function copy(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];
  var cb = arguments[3] === undefined ? null : arguments[3];

  if (typeof options === "function") {
    cb = options;
    options = null;
  }

  var cpx = new _Cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.clean(function (err) {
      if (err == null) {
        cpx.copy(cb);
      } else if (cb != null) {
        cb(err);
      }
    });
  } else {
    cpx.copy(cb);
  }

  return cpx;
}

function copySync(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];

  var cpx = new _Cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.cleanSync();
  }
  cpx.copySync();
}

function watch(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];

  var cpx = new _Cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.clean(function (err) {
      if (err == null) {
        cpx.watch();
      } else {
        cpx.emit("watch-error", err);
      }
    });
  } else {
    cpx.watch();
  }

  return cpx;
}