"use strict";

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assert$assertType = require("./utils");

var TAIL = Symbol("tail");

function dequeue(queue, item) {
  item.action(function () {
    if (item.next) {
      setImmediate(dequeue, queue, item.next);
    } else {
      _assert$assertType.assert(queue[TAIL] === item);
      queue[TAIL] = null;
    }
  });
}

var Queue = (function () {
  function Queue() {
    _classCallCheck(this, Queue);

    this[TAIL] = null;
  }

  _createClass(Queue, [{
    key: "push",
    value: function push(action) {
      _assert$assertType.assertType(action, "action", "function");

      var item = { action: action, next: null };
      if (this[TAIL] != null) {
        this[TAIL].next = item;
        this[TAIL] = item;
      } else {
        this[TAIL] = item;
        setImmediate(dequeue, this, item);
      }
    }
  }]);

  return Queue;
})();

exports["default"] = Queue;
module.exports = exports["default"];