"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assert = assert;
exports.assertType = assertType;
exports.assertTypeOpt = assertTypeOpt;

function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}

function assertType(value, name, type) {
  if (typeof value !== type) {
    throw new TypeError("" + name + " should be a " + type + ".");
  }
}

function assertTypeOpt(value, name, type) {
  if (value != null && typeof value !== type) {
    throw new TypeError("" + name + " should be a " + type + " or null.");
  }
}